local _, class = UnitClass("player")
if class == "MAGE" then

function MageCandy_CreateUI()
local backdrop = {edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12}

CreateFrame("Frame", "MCSpellStealNotification", UIParent)
MCSpellStealNotification:SetWidth(32)
MCSpellStealNotification:SetHeight(32)
MCSpellStealNotification:SetPoint("CENTER", UIParent, "CENTER")
MCSpellStealNotification:CreateTexture("MCSpellStealIcon")
MCSpellStealIcon:SetAllPoints()
MCSpellStealIcon:SetTexture(GetSpellTexture(12042))
MCSpellStealNotification:Hide()

CreateFrame("Frame", "MCTargetSpellStealFrame", UIParent)
MCTargetSpellStealFrame:SetPoint("CENTER", UIParent, "CENTER", -250, 0)
MCTargetSpellStealFrame:SetHeight(56)
MCTargetSpellStealFrame:SetWidth(152)
CreateFrame("Frame", "MCTargetSpellStealFrameBackground", MCTargetSpellStealFrame)
MCTargetSpellStealFrameBackground:SetAllPoints()
MCTargetSpellStealFrameBackground:SetPoint("CENTER")
MCTargetSpellStealFrameBackground:CreateTexture("MCTargetSpellStealFrameBG", "BACKGROUND")
MCTargetSpellStealFrameBG:SetWidth(MCTargetSpellStealFrame:GetWidth() - 5)
MCTargetSpellStealFrameBG:SetHeight(MCTargetSpellStealFrame:GetHeight() - 5)
MCTargetSpellStealFrameBG:SetPoint("CENTER")
MCTargetSpellStealFrameBG:SetTexture(0,0,0,.5)
MCTargetSpellStealFrameBackground:SetBackdrop(backdrop)
MCTargetSpellStealFrame:Hide()
MCTargetSpellStealFrame:CreateFontString("MCTargetSpellStealFrameHeader", "OVERLAY", "GameFontNormal")
MCTargetSpellStealFrameHeader:SetText("Spellsteal Target")
MCTargetSpellStealFrameHeader:SetPoint("BOTTOM", MCTargetSpellStealFrame, "TOP", 0, 1)
MCTargetSpellStealFrameHeader:SetTextColor(0,1,1)


CreateFrame("Frame", "MCFocusSpellStealFrame", UIParent)
MCFocusSpellStealFrame:SetPoint("CENTER", UIParent, "CENTER", 250, 0)
MCFocusSpellStealFrame:SetHeight(56)
MCFocusSpellStealFrame:SetWidth(152)
CreateFrame("Frame", "MCFocusSpellStealFrameBackground", MCFocusSpellStealFrame)
MCFocusSpellStealFrameBackground:SetAllPoints()
MCFocusSpellStealFrameBackground:SetPoint("CENTER")
MCFocusSpellStealFrameBackground:CreateTexture("MCFocusSpellStealFrameBG", "BACKGROUND")
MCFocusSpellStealFrameBG:SetWidth(MCFocusSpellStealFrame:GetWidth() - 5)
MCFocusSpellStealFrameBG:SetHeight(MCFocusSpellStealFrame:GetHeight() - 5)
MCFocusSpellStealFrameBG:SetPoint("CENTER")
MCFocusSpellStealFrameBG:SetTexture(0,0,0,.5)
MCFocusSpellStealFrame:Hide()
MCFocusSpellStealFrameBackground:SetBackdrop(backdrop)
MCFocusSpellStealFrame:CreateFontString("MCFocusSpellStealFrameHeader", "OVERLAY", "GameFontNormal")
MCFocusSpellStealFrameHeader:SetText("Spellsteal Focus")
MCFocusSpellStealFrameHeader:SetPoint("BOTTOM", MCFocusSpellStealFrame, "TOP", 0, 1)
MCFocusSpellStealFrameHeader:SetTextColor(0,1,1)

CreateFrame("Frame", "MCStolenSpellsFrame", UIParent)
MCStolenSpellsFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -150)
MCStolenSpellsFrame:SetHeight(56)
MCStolenSpellsFrame:SetWidth(152)
CreateFrame("Frame", "MCStolenSpellsFrameBackground", MCStolenSpellsFrame)
MCStolenSpellsFrameBackground:SetAllPoints()
MCStolenSpellsFrameBackground:SetPoint("CENTER")
MCStolenSpellsFrameBackground:CreateTexture("MCStolenSpellsFrameBG", "BACKGROUND")
MCStolenSpellsFrameBG:SetWidth(MCStolenSpellsFrame:GetWidth() - 5)
MCStolenSpellsFrameBG:SetHeight(MCStolenSpellsFrame:GetHeight() - 5)
MCStolenSpellsFrameBG:SetPoint("CENTER")
MCStolenSpellsFrameBG:SetTexture(0,0,0,.5)
MCStolenSpellsFrame:Hide()
MCStolenSpellsFrameBackground:SetBackdrop(backdrop)
MCStolenSpellsFrame:CreateFontString("MCStolenSpellsFrameHeader", "OVERLAY", "GameFontNormal")
MCStolenSpellsFrameHeader:SetText("Stolen Spells")
MCStolenSpellsFrameHeader:SetPoint("BOTTOM", MCStolenSpellsFrame, "TOP", 0, 1)
MCStolenSpellsFrameHeader:SetTextColor(0,1,1)

--Create Polymorph Monitor---------------------------
CreateFrame("Frame", "MCPolymorphMonitor", UIParent)
MCPolymorphMonitor:SetPoint("CENTER", UIParent, "CENTER", 0, -80)
MCPolymorphMonitor:SetWidth(32)
MCPolymorphMonitor:SetHeight(32)
MCPolymorphMonitor:CreateTexture("MCPolymorphMonitorIcon")
MCPolymorphMonitorIcon:SetAllPoints()
MCPolymorphMonitorIcon:SetTexture(GetSpellTexture(118))
MCPolymorphMonitor:CreateFontString("MCPolymorphMonitorText", "OVERLAY", "GameFontNormal")
MCPolymorphMonitorText:SetPoint("LEFT", MCPolymorphMonitor, "RIGHT", 2, 10)
MCPolymorphMonitorText:SetTextHeight(9)
MCPolymorphMonitor:CreateTexture("MCPolymorphMonitorBG", "BACKGROUND")
MCPolymorphMonitorBG:SetPoint("LEFT", MCPolymorphMonitor, "LEFT", -1.5, 0)
MCPolymorphMonitorBG:SetHeight(35)
MCPolymorphMonitorBG:SetWidth(158)
MCPolymorphMonitorBG:SetTexture(0, 0, 0, 0.8)
CreateFrame("StatusBar", "MCPolymorphMonitorBar", MCPolymorphMonitor)
MCPolymorphMonitorBar:SetWidth(120)
MCPolymorphMonitorBar:SetHeight(10)
MCPolymorphMonitorBar:SetPoint("BOTTOMLEFT", MCPolymorphMonitor, "BOTTOMRIGHT")
MCPolymorphMonitorBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MCPolymorphMonitorBar:SetStatusBarColor(0, 1, 1)
MCPolymorphMonitorBar:CreateFontString("MCPolymorphMonitorBarText", "OVERLAY", "GameFontNormal")
MCPolymorphMonitorBarText:SetPoint("CENTER", MCPolymorphMonitorBar, "CENTER")
MCPolymorphMonitorBarText:SetTextColor(1, 1, 1)
MCPolymorphMonitorBarText:SetTextHeight(11)
MCPolymorphMonitor:Hide()

-------------------------------------------------------



CreateFrame("Frame", "MCTimer", UIParent)
MCTimer:SetScript("OnUpdate", MageCandy_MCTimerOnUpdate)


-- Finish Setting Up Frames --
MCSpellStealNotification:EnableMouse(false)
MageCandy_SetupFrame(MCTargetSpellStealFrame)
MageCandy_SetupFrame(MCFocusSpellStealFrame)
MageCandy_SetupFrame(MCStolenSpellsFrame)
MageCandy_SetupFrame(MCPolymorphMonitor)
end


-- Just Saves Me Some Typing =) --
function MageCandy_SetupFrame(frame)
frame:SetFrameStrata("MEDIUM")
frame:SetToplevel()
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:RegisterForDrag("LeftButton")
frame:EnableMouse(true)
frame:SetMovable(true)
end

function MageCandy_LockFrames()
MCFocusSpellStealFrame:StopMovingOrSizing()
MCFocusSpellStealFrame:EnableMouse(false)
MCTargetSpellStealFrame:StopMovingOrSizing()
MCTargetSpellStealFrame:EnableMouse(false)
MCStolenSpellsFrame:StopMovingOrSizing()
MCStolenSpellsFrame:EnableMouse(false)
MCPolymorphMonitor:StopMovingOrSizing()
MCPolymorphMonitor:EnableMouse(false)
end

function MageCandy_UnlockFrames(bypass)
local value

if bypass then
value = true
elseif MageCandy_Options.lockframes == 0 then
value = true
elseif MageCandy_Options.lockframes == 1 then
value = false
end

MCFocusSpellStealFrame:EnableMouse(value)
MCTargetSpellStealFrame:EnableMouse(value)
MCStolenSpellsFrame:EnableMouse(value)
MCPolymorphMonitor:EnableMouse(value)
end

function MageCandy_HideFrames()
MCStolenSpellsFrame:Hide()
MCTargetSpellStealFrame:Hide()
MCFocusSpellStealFrame:Hide()
end

function MageCandy_Show(frame, value)
if value == 1 then
frame:Show()
else
frame:Hide()
end
end

function MageCandy_ShowFrames()
MCtimerbypass = 30
MCTargetSpellStealFrame:Show()
MCFocusSpellStealFrame:Show()
MCStolenSpellsFrame:Show()
MCPolymorphMonitor:Show()
MCPolymorphMonitorBar:SetMinMaxValues(0, 30)
MCPolymorphMonitorText:SetText("Polymorph Timer")
MageCandy_UnlockFrames(true)
end

function MageCandy_RepositionBuffs()
local frame
---------------------------------------------------------------------------------
for idx = 1, 12 do
if _G["MCTargetSpellStealFrameBuff"..idx] then
frame = _G["MCTargetSpellStealFrameBuff"..idx]
frame:ClearAllPoints()
else
break
end
if MageCandy_Options.flipbuffs == 1 then
if idx == 1 then 
frame:SetPoint("BOTTOMLEFT", MCTargetSpellStealFrame, "BOTTOMLEFT", 5.5, 5.5)
elseif idx == 7 then
frame:SetPoint("BOTTOMLEFT", MCTargetSpellStealFrameBuff1, "TOPLEFT", 0, 3)
else
frame:SetPoint("LEFT", _G["MCTargetSpellStealFrameBuff"..idx-1], "RIGHT", 3, 0)
end
else
if idx == 1 then 
frame:SetPoint("TOPLEFT", MCTargetSpellStealFrame, "TOPLEFT", 5.5, -5.5)
elseif idx == 7 then
frame:SetPoint("TOPLEFT", MCTargetSpellStealFrameBuff1, "BOTTOMLEFT", 0, -3)
else
frame:SetPoint("LEFT", _G["MCTargetSpellStealFrameBuff"..idx-1], "RIGHT", 3, 0)
end
end
end
------------------------------------------------------------------------------------
for idx = 1, 12 do
if _G["MCFocusSpellStealFrameBuff"..idx] then
frame = _G["MCFocusSpellStealFrameBuff"..idx]
frame:ClearAllPoints()
else
break
end
if MageCandy_Options.flipbuffs == 1 then
if idx == 1 then 
frame:SetPoint("BOTTOMLEFT", MCFocusSpellStealFrame, "BOTTOMLEFT", 5.5, 5.5)
elseif idx == 7 then
frame:SetPoint("BOTTOMLEFT", MCFocusSpellStealFrameBuff1, "TOPLEFT", 0, 3)
else
frame:SetPoint("LEFT", _G["MCFocusSpellStealFrameBuff"..idx-1], "RIGHT", 3, 0)
end
else
if idx == 1 then 
frame:SetPoint("TOPLEFT", MCFocusSpellStealFrame, "TOPLEFT", 5.5, -5.5)
elseif idx == 7 then
frame:SetPoint("TOPLEFT", MCFocusSpellStealFrameBuff1, "BOTTOMLEFT", 0, -3)
else
frame:SetPoint("LEFT", _G["MCFocusSpellStealFrameBuff"..idx-1], "RIGHT", 3, 0)
end
end
end
-------------------------------------------------------------------------------
for idx = 1, 12 do
if _G["MCStolenSpellsFrameBuff"..idx] then
frame = _G["MCStolenSpellsFrameBuff"..idx]
frame:ClearAllPoints()
else
break
end
if MageCandy_Options.flipbuffs == 1 then
if idx == 1 then 
frame:SetPoint("BOTTOMLEFT", MCStolenSpellsFrame, "BOTTOMLEFT", 5.5, 5.5)
elseif idx == 7 then
frame:SetPoint("BOTTOMLEFT", MCStolenSpellsFrameBuff1, "TOPLEFT", 0, 3)
else
frame:SetPoint("LEFT", _G["MCStolenSpellsFrameBuff"..idx-1], "RIGHT", 3, 0)
end
else
if idx == 1 then 
frame:SetPoint("TOPLEFT", MCStolenSpellsFrame, "TOPLEFT", 5.5, -5.5)
elseif idx == 7 then
frame:SetPoint("TOPLEFT", MCStolenSpellsFrameBuff1, "BOTTOMLEFT", 0, -3)
else
frame:SetPoint("LEFT", _G["MCStolenSpellsFrameBuff"..idx-1], "RIGHT", 3, 0)
end
end
end

end

function MageCandy_UpdateUI()

if MageCandy_Options.lockframes == 1 then
MageCandy_LockFrames()
else
MageCandy_UnlockFrames()
end

-- hide manually because events wont fire for these frames if they are hidden, which makes less work for the computer.

if MageCandy_Options.enablepolymorphmonitor == 0 then
MCPolymorphMonitor:Hide()
end

if MageCandy_Options.enablespellstealmonitor == 0 then
MCTargetSpellStealFrame:Hide()
MCFocusSpellStealFrame:Hide()
MCStolenSpellsFrame:Hide()
else
if MageCandy_Options.show.mctargetspellstealframe == 0 then
MCTargetSpellStealFrame:Hide()
end
if MageCandy_Options.show.mcfocusspellstealframe == 0 then
MCFocusSpellStealFrame:Hide()
end
if MageCandy_Options.show.mcstolenspellsframe == 0 then
MCStolenSpellsFrame:Hide()
end
end

MageCandy_Show(MCFocusSpellStealFrameBackground, MageCandy_Options.show.mcspellstealmonitorbackground)
MageCandy_Show(MCTargetSpellStealFrameBackground, MageCandy_Options.show.mcspellstealmonitorbackground)
MageCandy_Show(MCStolenSpellsFrameBackground, MageCandy_Options.show.mcspellstealmonitorbackground)
MageCandy_Show(MCFocusSpellStealFrameHeader, MageCandy_Options.show.mcspellstealmonitorheader)
MageCandy_Show(MCTargetSpellStealFrameHeader, MageCandy_Options.show.mcspellstealmonitorheader)
MageCandy_Show(MCStolenSpellsFrameHeader, MageCandy_Options.show.mcspellstealmonitorheader)

MCSpellStealNotification:SetWidth(32 * MageCandy_Options.scale.mcspellstealnotification)
MCSpellStealNotification:SetHeight(32 * MageCandy_Options.scale.mcspellstealnotification)



end




end
