local _, class = UnitClass("player")
if class == "MAGE" then

function MageCandy_CreateOptionsMenu()
local x, y, xoff, yoff = 0, 0, 15, -20
MageCandy = {}
MageCandy.panel = CreateFrame("Frame", "MCOptions", UIParent)
MageCandy.panel.name = "Mage Candy"
InterfaceOptions_AddCategory(MageCandy.panel)
MageCandy.panel.default = function()
MageCandy_Defaults()
if MCtimerbypass == 0 then
MageCandy_UpdateUI()
end
end

MageCandy.panel.okay = function()
MageCandy_Apply()
end
MageCandy.panel.cancel = function()
MageCandy_Cancel()
end
MageCandy.panel.refresh = function()
MageCandy_Cancel()
end


MCapply = CreateFrame("Button", "MCApply", MageCandy.panel, "UIPanelButtonTemplate")
MCapply:SetHeight(20)
MCapply:SetWidth(70)
MCapply:SetText(MageCandyLocal["APPLY"])
MCapply:ClearAllPoints()
MCapply:SetPoint("CENTER", MageCandy.panel, "BOTTOMRIGHT", -50, 20)
MCapply:SetScript("OnClick", MageCandy_Apply)

MCshowframes = CreateFrame("Button", "MCShowFrames", MageCandy.panel, "GameMenuButtonTemplate")
MCshowframes:SetWidth(140)
MCshowframes:SetHeight(40)
MCshowframes:SetPoint("BOTTOM", MageCandy.panel, "BOTTOM", 0, 60)
MCshowframes:SetText(MageCandyLocal["SHOW_ALL_FRAMES"])
MCshowframes:SetScript("OnClick", MageCandy_ShowFrames)
----------------------------------------------------------------------
y = 0
y = y + yoff
MCLockFrames = CreateFrame("CheckButton", "MCLockFrames", MageCandy.panel, "ChatConfigCheckButtonTemplate")
MCLockFrames:SetPoint("TOPLEFT", 15, y)
MCLockFramesText:SetText("Lock Frames")
MCLockFrames:SetChecked(MageCandy_Options.lockframes)
------------------------------------------------------------------------


-- Polymorph Monitor --------------------------------------------------
MageCandy.pmonitor = CreateFrame("Frame", "MCPolymorphMonitorOptions", UIParent)
MageCandy.pmonitor.name = MageCandyLocal["POLYMORPH_MONITOR"]
MageCandy.pmonitor.parent = MageCandy.panel.name
InterfaceOptions_AddCategory(MageCandy.pmonitor)

MageCandy.pmonitor.default = function()
MageCandy_Defaults()
if MCtimerbypass == 0 then
MageCandy_UpdateUI()
end
end
MageCandy.pmonitor.okay = function()
MageCandy_Apply()
end
MageCandy.pmonitor.cancel = function()
MageCandy_Cancel()
end
MageCandy.pmonitor.refresh = function()
MageCandy_Cancel()
end

MCpmonitorapply = CreateFrame("Button", "MCpmonitorApply", MageCandy.pmonitor, "UIPanelButtonTemplate")
MCpmonitorapply:SetHeight(20)
MCpmonitorapply:SetWidth(70)
MCpmonitorapply:SetText(MageCandyLocal["APPLY"])
MCpmonitorapply:ClearAllPoints()
MCpmonitorapply:SetPoint("CENTER", MageCandy.pmonitor, "BOTTOMRIGHT", -50, 20)
MCpmonitorapply:SetScript("OnClick", MageCandy_Apply)

------------------------------------------------------------------------
y = 0
y = y + yoff
MCEnablePolymorphMonitor = CreateFrame("CheckButton", "MCEnablePolymorphMonitor", MageCandy.pmonitor, "ChatConfigCheckButtonTemplate")
MCEnablePolymorphMonitor:SetPoint("TOPLEFT", 15, y)
MCEnablePolymorphMonitorText:SetText(MageCandyLocal["ENABLE_POLYMORPH_MONITOR"])
MCEnablePolymorphMonitor:SetChecked(MageCandy_Options.enablepolymorphmonitor)
------------------------------------------------------------------------
y = y + yoff
MCPolymorphMonitorShow = CreateFrame("CheckButton", "MCPolymorphMonitorShow", MageCandy.pmonitor, "ChatConfigCheckButtonTemplate")
MCPolymorphMonitorShow:SetPoint("TOPLEFT", 15, y)
MCPolymorphMonitorShowText:SetText(MageCandyLocal["SHOW_POLYMORPH_TIMER"])
MCPolymorphMonitorShow:SetChecked(MageCandy_Options.show.mcpolymorphmonitor)
------------------------------------------------------------------------
y = y + yoff
MCPolymorphApplyNotificationShow = CreateFrame("CheckButton", "MCPolymorphApplyNotificationShow", MageCandy.pmonitor, "ChatConfigCheckButtonTemplate")
MCPolymorphApplyNotificationShow:SetPoint("TOPLEFT", 15, y)
MCPolymorphApplyNotificationShowText:SetText(MageCandyLocal["POLYMORPH_APPLY_SHOW"])
MCPolymorphApplyNotificationShow:SetChecked(MageCandy_Options.show.polymorphapplynotification)
------------------------------------------------------------------------
y = y + yoff
MCPolymorphRemoveNotificationShow = CreateFrame("CheckButton", "MCPolymorphRemoveNotificationShow", MageCandy.pmonitor, "ChatConfigCheckButtonTemplate")
MCPolymorphRemoveNotificationShow:SetPoint("TOPLEFT", 15, y)
MCPolymorphRemoveNotificationShowText:SetText(MageCandyLocal["POLYMORPH_REMOVE_SHOW"])
MCPolymorphRemoveNotificationShow:SetChecked(MageCandy_Options.show.polymorphremovenotification)
------------------------------------------------------------------------
y = y + (yoff * 2)
CreateFrame("Slider","MCPolymorphMonitorScale", MageCandy.pmonitor)
MCPolymorphMonitorScale:SetPoint("TOPLEFT", 15, y)
MCPolymorphMonitorScale:SetWidth(600)
MCPolymorphMonitorScale:SetHeight(20)
MCPolymorphMonitorScale:SetOrientation("HORIZONTAL")
MCPolymorphMonitorScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MCPolymorphMonitorScale:SetMinMaxValues(0.5,5)
MCPolymorphMonitorScale:SetValue(0)
MCPolymorphMonitorScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MCPolymorphMonitorScale:SetScript("OnValueChanged", function (self, value) MCPolymorphMonitorScaleText:SetText(string.sub(value, 1, 4)) MCPolymorphMonitor:SetScale(value) end)
MageCandy.pmonitor:CreateFontString("MCPolymorphMonitorScaleHeader", "OVERLAY", "GameFontNormal")
MCPolymorphMonitorScaleHeader:SetPoint("BOTTOMLEFT", MCPolymorphMonitorScale, "TOPLEFT")
MCPolymorphMonitorScaleHeader:SetText(MageCandyLocal["POLYMORPH_TIMER_SCALE"])
MageCandy.pmonitor:CreateFontString("MCPolymorphMonitorScaleText", "OVERLAY", "GameFontNormal")
MCPolymorphMonitorScaleText:SetPoint("BOTTOMRIGHT", MCPolymorphMonitorScale, "TOPRIGHT")
MCPolymorphMonitorScaleText:SetText(string.sub(MageCandy_Options.scale.mcpolymorphmonitor, 1, 4))
-----------------------------------------------------------------------


-- Spellsteal Monitor --------------------------------------------------
MageCandy.ssmonitor = CreateFrame("Frame", "MCSpellStealMonitorOptions", UIParent)
MageCandy.ssmonitor.name = MageCandyLocal["SPELLSTEAL_MONITOR"]
MageCandy.ssmonitor.parent = MageCandy.panel.name
InterfaceOptions_AddCategory(MageCandy.ssmonitor)

MageCandy.ssmonitor.default = function()
MageCandy_Defaults()
if MCtimerbypass == 0 then
MageCandy_UpdateUI()
end
end
MageCandy.ssmonitor.okay = function()
MageCandy_Apply()
end
MageCandy.ssmonitor.cancel = function()
MageCandy_Cancel()
end
MageCandy.ssmonitor.refresh = function()
MageCandy_Cancel()
end

MCssmonitorapply = CreateFrame("Button", "MCssmonitorApply", MageCandy.ssmonitor, "UIPanelButtonTemplate")
MCssmonitorapply:SetHeight(20)
MCssmonitorapply:SetWidth(70)
MCssmonitorapply:SetText(MageCandyLocal["APPLY"])
MCssmonitorapply:ClearAllPoints()
MCssmonitorapply:SetPoint("CENTER", MageCandy.ssmonitor, "BOTTOMRIGHT", -50, 20)
MCssmonitorapply:SetScript("OnClick", MageCandy_Apply)

MCTestSSAnimation = CreateFrame("Button", "MCTestSSAnimation", MageCandy.ssmonitor, "UIPanelButtonTemplate")
MCTestSSAnimation:SetHeight(30)
MCTestSSAnimation:SetWidth(120)
MCTestSSAnimation:SetText(MageCandyLocal["PLAY_ANIMATION"])
MCTestSSAnimation:ClearAllPoints()
MCTestSSAnimation:SetPoint("CENTER", MageCandy.ssmonitor, "CENTER", 0, -150)
MCTestSSAnimation:SetScript("OnClick", function () MCSpellStealNotification:Show() end)

------------------------------------------------------------------------
y = 0
y = y + yoff
MCSpellStealMonitorBackgroundShow = CreateFrame("CheckButton", "MCSpellStealMonitorBackgroundShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCSpellStealMonitorBackgroundShow:SetPoint("TOP", 15, y)
MCSpellStealMonitorBackgroundShowText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_BACKGROUND_SHOW"])
MCSpellStealMonitorBackgroundShow:SetChecked(MageCandy_Options.show.mcspellstealmonitorbackground)
------------------------------------------------------------------------
------------------------------------------------------------------------
y = y + yoff
MCSpellStealMonitorHeaderShow = CreateFrame("CheckButton", "MCSpellStealMonitorHeaderShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCSpellStealMonitorHeaderShow:SetPoint("TOP", 15, y)
MCSpellStealMonitorHeaderShowText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_HEADER_SHOW"])
MCSpellStealMonitorHeaderShow:SetChecked(MageCandy_Options.show.mcspellstealmonitorheader)
------------------------------------------------------------------------
y = y + yoff
MCSpellStealMonitorFlipBuffs = CreateFrame("CheckButton", "MCSpellStealMonitorFlipBuffs", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCSpellStealMonitorFlipBuffs:SetPoint("TOP", 15, y)
MCSpellStealMonitorFlipBuffsText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_FLIP_BUFFS"])
MCSpellStealMonitorFlipBuffs:SetChecked(MageCandy_Options.flipbuffs)
------------------------------------------------------------------------
y = y + yoff
MCSpellStealMessageShow = CreateFrame("CheckButton", "MCSpellStealMessageShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCSpellStealMessageShow:SetPoint("TOP", 15, y)
MCSpellStealMessageShowText:SetText(MageCandyLocal["SPELLSTEAL_MESSAGE_SHOW"])
MCSpellStealMessageShow:SetChecked(MageCandy_Options.show.mcspellstealmessage)
------------------------------------------------------------------------

------------------------------------------------------------------------
y = 0
y = y + yoff
MCEnableSpellStealMonitor = CreateFrame("CheckButton", "MCEnableSpellStealMonitor", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCEnableSpellStealMonitor:SetPoint("TOPLEFT", 15, y)
MCEnableSpellStealMonitorText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_ENABLE"])
MCEnableSpellStealMonitor:SetChecked(MageCandy_Options.enablespellstealmonitor)
------------------------------------------------------------------------
y = y + yoff
MCSpellStealNotificationShow = CreateFrame("CheckButton", "MCSpellStealNotificationShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCSpellStealNotificationShow:SetPoint("TOPLEFT", 15, y)
MCSpellStealNotificationShowText:SetText(MageCandyLocal["SPELLSTEAL_NOTIFICATION_SHOW"])
MCSpellStealNotificationShow:SetChecked(MageCandy_Options.show.mcspellstealnotification)
------------------------------------------------------------------------
y = y + yoff
MCTargetSpellStealFrameShow = CreateFrame("CheckButton", "MCTargetSpellStealFrameShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCTargetSpellStealFrameShow:SetPoint("TOPLEFT", 15, y)
MCTargetSpellStealFrameShowText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_SHOW_TARGET"])
MCTargetSpellStealFrameShow:SetChecked(MageCandy_Options.show.mctargetspellstealframe)
------------------------------------------------------------------------
y = y + yoff
MCFocusSpellStealFrameShow = CreateFrame("CheckButton", "MCFocusSpellStealFrameShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCFocusSpellStealFrameShow:SetPoint("TOPLEFT", 15, y)
MCFocusSpellStealFrameShowText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_SHOW_FOCUS"])
MCFocusSpellStealFrameShow:SetChecked(MageCandy_Options.show.mcfocusspellstealframe)
------------------------------------------------------------------------
y = y + yoff
MCStolenSpellsFrameShow = CreateFrame("CheckButton", "MCStolenSpellsFrameShow", MageCandy.ssmonitor, "ChatConfigCheckButtonTemplate")
MCStolenSpellsFrameShow:SetPoint("TOPLEFT", 15, y)
MCStolenSpellsFrameShowText:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_SHOW_STOLEN"])
MCStolenSpellsFrameShow:SetChecked(MageCandy_Options.show.mcstolenspellsframe)
-----------------------------------------------------------------------
y = y + (yoff * 4)
CreateFrame("Slider","MCTargetSpellStealFrameScale", MageCandy.ssmonitor)
MCTargetSpellStealFrameScale:SetPoint("TOPLEFT", 15, y)
MCTargetSpellStealFrameScale:SetWidth(600)
MCTargetSpellStealFrameScale:SetHeight(20)
MCTargetSpellStealFrameScale:SetOrientation("HORIZONTAL")
MCTargetSpellStealFrameScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MCTargetSpellStealFrameScale:SetMinMaxValues(0.5,5)
MCTargetSpellStealFrameScale:SetValue(0)
MCTargetSpellStealFrameScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MCTargetSpellStealFrameScale:SetScript("OnValueChanged", function (self, value) MCTargetSpellStealFrameScaleText:SetText(string.sub(value, 1, 4)) MCTargetSpellStealFrame:SetScale(value) end)
MageCandy.ssmonitor:CreateFontString("MCTargetSpellStealFrameScaleHeader", "OVERLAY", "GameFontNormal")
MCTargetSpellStealFrameScaleHeader:SetPoint("BOTTOMLEFT", MCTargetSpellStealFrameScale, "TOPLEFT")
MCTargetSpellStealFrameScaleHeader:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_TARGET_SCALE"])
MageCandy.ssmonitor:CreateFontString("MCTargetSpellStealFrameScaleText", "OVERLAY", "GameFontNormal")
MCTargetSpellStealFrameScaleText:SetPoint("BOTTOMRIGHT", MCTargetSpellStealFrameScale, "TOPRIGHT")
MCTargetSpellStealFrameScaleText:SetText(string.sub(MageCandy_Options.scale.mctargetspellstealframe, 1, 4))
-----------------------------------------------------------------------
y = y + (yoff * 2)
CreateFrame("Slider","MCFocusSpellStealFrameScale", MageCandy.ssmonitor)
MCFocusSpellStealFrameScale:SetPoint("TOPLEFT", 15, y)
MCFocusSpellStealFrameScale:SetWidth(600)
MCFocusSpellStealFrameScale:SetHeight(20)
MCFocusSpellStealFrameScale:SetOrientation("HORIZONTAL")
MCFocusSpellStealFrameScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MCFocusSpellStealFrameScale:SetMinMaxValues(0.5,5)
MCFocusSpellStealFrameScale:SetValue(0)
MCFocusSpellStealFrameScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MCFocusSpellStealFrameScale:SetScript("OnValueChanged", function (self, value) MCFocusSpellStealFrameScaleText:SetText(string.sub(value, 1, 4)) MCFocusSpellStealFrame:SetScale(value) end)
MageCandy.ssmonitor:CreateFontString("MCFocusSpellStealFrameScaleHeader", "OVERLAY", "GameFontNormal")
MCFocusSpellStealFrameScaleHeader:SetPoint("BOTTOMLEFT", MCFocusSpellStealFrameScale, "TOPLEFT")
MCFocusSpellStealFrameScaleHeader:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_FOCUS_SCALE"])
MageCandy.ssmonitor:CreateFontString("MCFocusSpellStealFrameScaleText", "OVERLAY", "GameFontNormal")
MCFocusSpellStealFrameScaleText:SetPoint("BOTTOMRIGHT", MCFocusSpellStealFrameScale, "TOPRIGHT")
MCFocusSpellStealFrameScaleText:SetText(string.sub(MageCandy_Options.scale.mcfocusspellstealframe, 1, 4))
-----------------------------------------------------------------------
y = y + (yoff * 2)
CreateFrame("Slider","MCStolenSpellsFrameScale", MageCandy.ssmonitor)
MCStolenSpellsFrameScale:SetPoint("TOPLEFT", 15, y)
MCStolenSpellsFrameScale:SetWidth(600)
MCStolenSpellsFrameScale:SetHeight(20)
MCStolenSpellsFrameScale:SetOrientation("HORIZONTAL")
MCStolenSpellsFrameScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MCStolenSpellsFrameScale:SetMinMaxValues(0.5,5)
MCStolenSpellsFrameScale:SetValue(0)
MCStolenSpellsFrameScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MCStolenSpellsFrameScale:SetScript("OnValueChanged", function (self, value) MCStolenSpellsFrameScaleText:SetText(string.sub(value, 1, 4)) MCStolenSpellsFrame:SetScale(value) end)
MageCandy.ssmonitor:CreateFontString("MCStolenSpellsFrameScaleHeader", "OVERLAY", "GameFontNormal")
MCStolenSpellsFrameScaleHeader:SetPoint("BOTTOMLEFT", MCStolenSpellsFrameScale, "TOPLEFT")
MCStolenSpellsFrameScaleHeader:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_STOLEN_SCALE"])
MageCandy.ssmonitor:CreateFontString("MCStolenSpellsFrameScaleText", "OVERLAY", "GameFontNormal")
MCStolenSpellsFrameScaleText:SetPoint("BOTTOMRIGHT", MCStolenSpellsFrameScale, "TOPRIGHT")
MCStolenSpellsFrameScaleText:SetText(string.sub(MageCandy_Options.scale.mcstolenspellsframe, 1, 4))
-----------------------------------------------------------------------
y = y + (yoff * 2)
CreateFrame("Slider","MCSpellStealNotificationScale", MageCandy.ssmonitor)
MCSpellStealNotificationScale:SetPoint("TOPLEFT", 15, y)
MCSpellStealNotificationScale:SetWidth(600)
MCSpellStealNotificationScale:SetHeight(20)
MCSpellStealNotificationScale:SetOrientation("HORIZONTAL")
MCSpellStealNotificationScale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MCSpellStealNotificationScale:SetMinMaxValues(0.5,5)
MCSpellStealNotificationScale:SetValue(0)
MCSpellStealNotificationScale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MCSpellStealNotificationScale:SetScript("OnValueChanged", function (self, value) 
MCSpellStealNotificationScaleText:SetText(string.sub(value, 1, 4)) 
MCSpellStealNotification:SetWidth(32 * value)
MCSpellStealNotification:SetHeight(32 * value)
end)
MageCandy.ssmonitor:CreateFontString("MCSpellStealNotificationScaleHeader", "OVERLAY", "GameFontNormal")
MCSpellStealNotificationScaleHeader:SetPoint("BOTTOMLEFT", MCSpellStealNotificationScale, "TOPLEFT")
MCSpellStealNotificationScaleHeader:SetText(MageCandyLocal["SPELLSTEAL_MONITOR_NOTIFICATION_SCALE"])
MageCandy.ssmonitor:CreateFontString("MCSpellStealNotificationScaleText", "OVERLAY", "GameFontNormal")
MCSpellStealNotificationScaleText:SetPoint("BOTTOMRIGHT", MCSpellStealNotificationScale, "TOPRIGHT")
MCSpellStealNotificationScaleText:SetText(string.sub(MageCandy_Options.scale.mcspellstealnotification, 1, 4))
-------------------------------------------------------------------


SLASH_MAGECANDY1 = "/mc"
SLASH_MAGECANDY2 = "/magecandy"
SlashCmdList["MAGECANDY"] = function()
InterfaceOptionsFrame_OpenToCategory(MageCandy.panel)
InterfaceOptionsFrame_OpenToCategory(MageCandy.panel)
end
end


function MageCandy_Cancel()
MCSpellStealMonitorFlipBuffs:SetChecked(MageCandy_Options.flipbuffs)
MCEnableSpellStealMonitor:SetChecked(MageCandy_Options.enablespellstealmonitor)
MCLockFrames:SetChecked(MageCandy_Options.lockframes)
MCTargetSpellStealFrameScale:SetValue(MageCandy_Options.scale.mctargetspellstealframe)
MCFocusSpellStealFrameScale:SetValue(MageCandy_Options.scale.mcfocusspellstealframe)
MCStolenSpellsFrameScale:SetValue(MageCandy_Options.scale.mcstolenspellsframe)
MCSpellStealNotificationScale:SetValue(MageCandy_Options.scale.mcspellstealnotification)
MCSpellStealMessageShow:SetChecked(MageCandy_Options.show.mcspellstealmessage)
MCSpellStealMonitorBackgroundShow:SetChecked(MageCandy_Options.show.mcspellstealmonitorbackground)
MCSpellStealMonitorHeaderShow:SetChecked(MageCandy_Options.show.mcspellstealmonitorheader)
MCTargetSpellStealFrameShow:SetChecked(MageCandy_Options.show.mctargetspellstealframe)
MCFocusSpellStealFrameShow:SetChecked(MageCandy_Options.show.mcfocusspellstealframe)
MCStolenSpellsFrameShow:SetChecked(MageCandy_Options.show.mcstolenspellsframe)
MCSpellStealNotificationShow:SetChecked(MageCandy_Options.show.mcspellstealnotification)
MCPolymorphMonitorScale:SetValue(MageCandy_Options.scale.mcpolymorphmonitor)
MCPolymorphMonitorShow:SetChecked(MageCandy_Options.show.mcpolymorphmonitor)
MCPolymorphMonitorApplyNotificationShow:SetChecked(MageCandy_Options.show.polymorphapplynotification)
MCPolymorphMonitorRemoveNotificationShow:SetChecked(MageCandy_Options.show.polymorphremovenotification)
MCEnablePolymorphMonitor:SetChecked(MageCandy_Options.enablepolymorphmonitor)
if MCtimerbypass == 0 then
MageCandy_UpdateUI()
end
end

function MageCandy_Apply()
if MageCandy_Options.flipbuffs ~= MageCandy_Convert(MCSpellStealMonitorFlipBuffs:GetChecked()) then
MageCandy_Options.flipbuffs = MageCandy_Convert(MCSpellStealMonitorFlipBuffs:GetChecked())
MageCandy_RepositionBuffs()
else
MageCandy_Options.flipbuffs = MageCandy_Convert(MCSpellStealMonitorFlipBuffs:GetChecked())
end
MageCandy_Options.enablespellstealmonitor = MageCandy_Convert(MCEnableSpellStealMonitor:GetChecked())
MageCandy_Options.lockframes = MageCandy_Convert(MCLockFrames:GetChecked())
MageCandy_Options.scale.mctargetspellstealframe = MCTargetSpellStealFrameScale:GetValue()
MageCandy_Options.scale.mcfocusspellstealframe = MCFocusSpellStealFrameScale:GetValue()
MageCandy_Options.scale.mcstolenspellsframe = MCStolenSpellsFrameScale:GetValue()
MageCandy_Options.scale.mcspellstealnotification = MCSpellStealNotificationScale:GetValue()
MageCandy_Options.show.mcspellstealmessage = MageCandy_Convert(MCSpellStealMessageShow:GetChecked())
MageCandy_Options.show.mcspellstealmonitorbackground = MageCandy_Convert(MCSpellStealMonitorBackgroundShow:GetChecked())
MageCandy_Options.show.mcspellstealmonitorheader = MageCandy_Convert(MCSpellStealMonitorHeaderShow:GetChecked())
MageCandy_Options.show.mctargetspellstealframe = MageCandy_Convert(MCTargetSpellStealFrameShow:GetChecked())
MageCandy_Options.show.mcfocusspellstealframe = MageCandy_Convert(MCFocusSpellStealFrameShow:GetChecked())
MageCandy_Options.show.mcstolenspellsframe = MageCandy_Convert(MCStolenSpellsFrameShow:GetChecked())
MageCandy_Options.show.mcspellstealnotification = MageCandy_Convert(MCSpellStealNotificationShow:GetChecked())
MageCandy_Options.scale.mcpolymorphmonitor = MCPolymorphMonitorScale:GetValue()
MageCandy_Options.show.mcpolymorphmonitor = MageCandy_Convert(MCPolymorphMonitorShow:GetChecked())
MageCandy_Options.show.polymorphapplynotification = MageCandy_Convert(MCPolymorphApplyNotificationShow:GetChecked())
MageCandy_Options.show.polymorphremovenotification = MageCandy_Convert(MCPolymorphRemoveNotificationShow:GetChecked())
MageCandy_Options.enablepolymorphmonitor = MageCandy_Convert(MCEnablePolymorphMonitor:GetChecked())
if MCtimerbypass == 0 then
MageCandy_UpdateUI()
end
end

-- turns the nil value(unchecked box) into a number for storing in options table for later use
function MageCandy_Convert(arg)
if arg == nil then
return 0
else 
return arg
end
end

function MageCandy_Defaults()
MageCandy_Options = {
lockframes = 1,
enablespellstealmonitor = 1,
flipbuffs = 1,
enablepolymorphmonitor = 1,

scale = {
mctargetspellstealframe = 1,
mcfocusspellstealframe = 1,
mcstolenspellsframe = 1,
mcspellstealnotification = 1,
mcpolymorphmonitor = 1,

},

show = {
mctargetspellstealframe = 1,
mcfocusspellstealframe = 1,
mcstolenspellsframe = 1,
mcspellstealmessage = 1,
mcspellstealnotification = 1,
mcspellstealmonitorbackground = 1,
mcspellstealmonitorheader = 1,
mcpolymorphmonitor = 1,
polymorphapplynotification = 0,
polymorphremovenotification = 1,

},
}
end

function MageCandy_Check()
if not MageCandy_Options then
MageCandy_Defaults()
end



end



end
